/**
 */
package net.astah.stpa.stamp.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import net.astah.emf.edit.command.InitializeFeatureCommand;
import net.astah.stpa.stamp.Component;
import net.astah.stpa.stamp.ControlStructure;
import net.astah.stpa.stamp.STAMPFactory;
import net.astah.stpa.stamp.STAMPPackage;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.Component} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ComponentItemProvider extends LinkableElementItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ComponentItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addIsAnalysisTargetPropertyDescriptor(object);
            addResponsibilityPropertyDescriptor(object);
            addRemarksPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Is Analysis Target feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addIsAnalysisTargetPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Component_isAnalysisTarget_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Component_isAnalysisTarget_feature", "_UI_Component_type"),
                 STAMPPackage.Literals.COMPONENT__IS_ANALYSIS_TARGET,
                 true,
                 false,
                 false,
                 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Responsibility feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addResponsibilityPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Component_responsibility_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Component_responsibility_feature", "_UI_Component_type"),
                 STAMPPackage.Literals.COMPONENT__RESPONSIBILITY,
                 true,
                 true,
                 false,
                 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Remarks feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addRemarksPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Component_remarks_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Component_remarks_feature", "_UI_Component_type"),
                 STAMPPackage.Literals.COMPONENT__REMARKS,
                 true,
                 true,
                 false,
                 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                 null,
                 null));
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
        if (childrenFeatures == null) {
            super.getChildrenFeatures(object);
            childrenFeatures.add(STAMPPackage.Literals.COMPONENT__NESTED_COMPONENT);
            childrenFeatures.add(STAMPPackage.Literals.COMPONENT__PROCESS_MODEL);
        }
        return childrenFeatures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child) {
        // Check the type of the specified child object and return the proper feature to use for
        // adding (see {@link AddCommand}) it as a child.

        return super.getChildFeature(object, child);
    }

    /**
     * This returns Component.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/Component"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((Component)object).getName();
        return label == null || label.length() == 0 ?
            getString("_UI_Component_type") :
            getString("_UI_Component_type") + " " + label;
    }

    /**
     * This returns the label text for list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    @Override
    public String getModelListText(Object object) {
        return ((Component)object).getName();
    }

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(Component.class)) {
            case STAMPPackage.COMPONENT__IS_ANALYSIS_TARGET:
            case STAMPPackage.COMPONENT__RESPONSIBILITY:
            case STAMPPackage.COMPONENT__REMARKS:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
                return;
            case STAMPPackage.COMPONENT__NESTED_COMPONENT:
            case STAMPPackage.COMPONENT__PROCESS_MODEL:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.COMPONENT__NESTED_COMPONENT,
                 STAMPFactory.eINSTANCE.createComponent()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.COMPONENT__PROCESS_MODEL,
                 STAMPFactory.eINSTANCE.createProcessModel()));
    }

    /**
     * @generated NOT
     */
    @Override
    protected Command createCreateChildCommand(EditingDomain domain,
            EObject owner,
            EStructuralFeature feature,
            Object value,
            int index,
            Collection<?> collection) {
        Command command =
                super.createCreateChildCommand(domain, owner, feature, value, index, collection);
        switch (feature.getFeatureID()) {
        case STAMPPackage.COMPONENT__NESTED_COMPONENT:
            command = command.chain(InitializeFeatureCommand.create(domain, value,
                    STAMPPackage.Literals.NAMED_ELEMENT__NAME));
            break;
        case STAMPPackage.COMPONENT__PROCESS_MODEL:
            command = command.chain(InitializeFeatureCommand.create(domain, value,
                    STAMPPackage.Literals.NAMED_ELEMENT__NAME));
            break;
        }
        return command;
    }

    @Override
    protected EObject resolveEquivalent(final EditingDomain domain, final Object context,
            final EObject object, final EObject original) {
        final Component element = (Component) object;
        final Component result = resolveEquivalentComponent(domain, context, element, original);
        if (result != null) {
            return result;
        }
        return super.resolveEquivalent(domain, context, object, original);
    }

    private Component resolveEquivalentComponent(final EditingDomain domain,
            final Object context, final Component object, final EObject original) {
        // デフォルト実装による完全一致の対象を優先して検索する
        final EObject sameObject = super.resolveEquivalent(domain, context, object, original);
        if (sameObject instanceof Component) {
            return (Component) sameObject;
        }
        final String name = object.getName();
        if (name != null) {
            // 要素の名前で検索するスコープとなる名前空間を親要素またはペースト先から取得する
            final EObject container = resolveEquivalentContainer(domain, context, object);
            if (container instanceof ControlStructure) {
                final ControlStructure namespace = (ControlStructure) container;
                for (Component cmp : namespace.getComponents()) {
                    if (name.equals(cmp.getName())) {
                        return cmp;
                    }
                }
            }
        }
        return null;
    }
}
