/**
 */
package net.astah.stpa.stamp.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import net.astah.stpa.stamp.NoteAnchor;
import net.astah.stpa.stamp.STAMPFactory;
import net.astah.stpa.stamp.STAMPPackage;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.NoteAnchor} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class NoteAnchorItemProvider extends ElementItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NoteAnchorItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addOwnerPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Owner feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addOwnerPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_NoteAnchor_owner_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_NoteAnchor_owner_feature", "_UI_NoteAnchor_type"),
                 STAMPPackage.Literals.NOTE_ANCHOR__OWNER,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
        if (childrenFeatures == null) {
            super.getChildrenFeatures(object);
            childrenFeatures.add(STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT);
        }
        return childrenFeatures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child) {
        // Check the type of the specified child object and return the proper feature to use for
        // adding (see {@link AddCommand}) it as a child.

        return super.getChildFeature(object, child);
    }

    /**
     * This returns NoteAnchor.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/NoteAnchor"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        return getString("_UI_NoteAnchor_type");
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(NoteAnchor.class)) {
            case STAMPPackage.NOTE_ANCHOR__ANNOTATED_ELEMENT:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createSTPAAnalysis()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createNote()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createNoteAnchor()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createAccident()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createHazard()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createSafetyConstraint()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createPrecondition()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createControlStructure()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createComponent()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createProcessModel()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createProcessVariable()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createProcessValue()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createLinkEnd()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createCountermeasure()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createHazardCausalFactor()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createHazardScenario()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createUnsafeControlAction()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createControlAction()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createControlLink()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createUCAGuideWordSet()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createUCAGuideWord()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createHCFHintWordSet()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createHCFHintWord()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createUCAAnalysis()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createUCAAnalysisResult()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createHCFAnalysis()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createHCFAnalysisResult()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createControlLoop()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createFeedbackLink()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT,
                 STAMPFactory.eINSTANCE.createFeedback()));
    }

    /**
     * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
        Object childFeature = feature;
        Object childObject = child;

        boolean qualify =
            childFeature == STAMPPackage.Literals.ELEMENT__OWNED_NOTE ||
            childFeature == STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT;

        if (qualify) {
            return getString
                ("_UI_CreateChild_text2",
                 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
        }
        return super.getCreateChildText(owner, feature, child, selection);
    }

    @Override
    public Object resolveEquivalent(final EditingDomain domain, final Object context,
            final Object object, final Object original) {
        return null;
    }
}
