/**
 */
package net.astah.stpa.stamp.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemStyledLabelProvider;
import org.eclipse.emf.edit.provider.StyledString;
import org.eclipse.emf.edit.provider.StyledString.Style;

import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.UnsafeControlAction;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.UnsafeControlAction} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class UnsafeControlActionItemProvider extends IdentifiedElementItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UnsafeControlActionItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addControlActionPropertyDescriptor(object);
            addViolatingSafetyConstraintPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Control Action feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addControlActionPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_UnsafeControlAction_controlAction_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_UnsafeControlAction_controlAction_feature", "_UI_UnsafeControlAction_type"),
                 STAMPPackage.Literals.UNSAFE_CONTROL_ACTION__CONTROL_ACTION,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Violating Safety Constraint feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addViolatingSafetyConstraintPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_UnsafeControlAction_violatingSafetyConstraint_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_UnsafeControlAction_violatingSafetyConstraint_feature", "_UI_UnsafeControlAction_type"),
                 STAMPPackage.Literals.UNSAFE_CONTROL_ACTION__VIOLATING_SAFETY_CONSTRAINT,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This returns UnsafeControlAction.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/UnsafeControlAction"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((UnsafeControlAction)object).getId();
        return label == null || label.length() == 0 ?
            getString("_UI_UnsafeControlAction_type") :
            getString("_UI_UnsafeControlAction_type") + " " + label;
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);
    }

    /**
     * @see STAMPItemProviderAdapter#getTableCellText(Object)
     * @generated NOT
     */
    @Override
    public String getTableCellText(final Object object) {
        final UnsafeControlAction uca = (UnsafeControlAction) object;
        return "(" + uca.getId() + ") " + uca.getDescription();
    }

    /**
     * @see IItemStyledLabelProvider#getStyledText(Object)
     * @generated NOT
     */
    @Override
    public Object getStyledText(final Object object) {
        final StyledString styledText = new StyledString();
        final Style ucaStyle = StyledString.Style.newBuilder()
                .setForegroundColor(URI.createURI("color://rgb/255/0/0")).toStyle();
        final UnsafeControlAction uca = (UnsafeControlAction) object;
        final StringBuffer ucaText = new StringBuffer();
        ucaText.append("(" + uca.getId() + ") ");
        ucaText.append(uca.getDescription());
        if (!uca.getViolatingSafetyConstraints().isEmpty()) {
            ucaText.append("\n");
            uca.getViolatingSafetyConstraints()
                    .forEach(sc -> ucaText.append("[" + sc.getId() + "]"));
        }
        styledText.append(ucaText.toString(), ucaStyle);
        return styledText;
    }

}
