/**
 */
package net.astah.stpa.stamp.notation.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;

import net.astah.dd.di.edit.command.DiagramContext;
import net.astah.stpa.stamp.notation.STAMPControlLoopDiagram;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.notation.STAMPControlLoopDiagram} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class STAMPControlLoopDiagramItemProvider extends STAMPDiagramItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPControlLoopDiagramItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addControlLoopPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Control Loop feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addControlLoopPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPControlLoopDiagram_controlLoop_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPControlLoopDiagram_controlLoop_feature", "_UI_STAMPControlLoopDiagram_type"),
                 STAMPNotationPackage.Literals.STAMP_CONTROL_LOOP_DIAGRAM__CONTROL_LOOP,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This returns STAMPControlLoopDiagram.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/STAMPControlLoopDiagram"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((STAMPControlLoopDiagram)object).getName();
        return label == null || label.length() == 0 ?
            getString("_UI_STAMPControlLoopDiagram_type") :
            getString("_UI_STAMPControlLoopDiagram_type") + " " + label;
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);
    }

    @Override
    public Object getMoveVector(EditingDomain domain, Object context, Object owner,
            Collection<?> targetObjects) {

        if (context instanceof DiagramContext && ((DiagramContext) context).getDiagram() != owner && ((DiagramContext) context).getSelection() != null) {
            return super.getMoveVector(domain, context, ((DiagramContext) context).getDiagram(), ((DiagramContext) context).getSelection());
        }
        return super.getMoveVector(domain, context, owner, targetObjects);
    }

    /**
     * @generated NOT
     */
    @Override
    public void collectSharedComposites(final EditingDomain domain, final Object object,
            final Collection<Object> collection) {
        final STAMPControlLoopDiagram diagram = (STAMPControlLoopDiagram) object;
        addIfNotNull(collection, diagram.getControlLoop());
    }

}
