/**
 */
package net.astah.stpa.stamp.notation.provider;


import java.util.Collection;
import java.util.List;
import net.astah.notation.provider.DiagramElementItemProvider;
import net.astah.stpa.stamp.notation.STAMPDiagramElement;
import net.astah.stpa.stamp.notation.STAMPNotationFactory;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.notation.STAMPDiagramElement} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class STAMPDiagramElementItemProvider extends DiagramElementItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPDiagramElementItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addSTAMPModelElementPropertyDescriptor(object);
            addSTAMPTargetEdgePropertyDescriptor(object);
            addSTAMPSourceEdgePropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the STAMP Model Element feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPModelElementPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPDiagramElement_STAMPModelElement_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPDiagramElement_STAMPModelElement_feature", "_UI_STAMPDiagramElement_type"),
                 STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_MODEL_ELEMENT,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the STAMP Target Edge feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPTargetEdgePropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPDiagramElement_STAMPTargetEdge_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPDiagramElement_STAMPTargetEdge_feature", "_UI_STAMPDiagramElement_type"),
                 STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_TARGET_EDGE,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the STAMP Source Edge feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPSourceEdgePropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPDiagramElement_STAMPSourceEdge_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPDiagramElement_STAMPSourceEdge_feature", "_UI_STAMPDiagramElement_type"),
                 STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_SOURCE_EDGE,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
        if (childrenFeatures == null) {
            super.getChildrenFeatures(object);
            childrenFeatures.add(STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT);
        }
        return childrenFeatures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child) {
        // Check the type of the specified child object and return the proper feature to use for
        // adding (see {@link AddCommand}) it as a child.

        return super.getChildFeature(object, child);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        return getString("_UI_STAMPDiagramElement_type");
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(STAMPDiagramElement.class)) {
            case STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPEdge()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPDiagram()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPLabel()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPCompartment()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPCompartmentableShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPComponentShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPGraphicalShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPControlStructureDiagram()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPControlLoopDiagram()));
    }

    /**
     * Return the resource locator for this item provider's resources.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator() {
        return STAMPNotationEditPlugin.INSTANCE;
    }

}
