/**
 */
package net.astah.stpa.stamp.notation.provider;


import static net.astah.emf.edit.command.DiagramCommands.getClippedFragment;
import static net.astah.stpa.stamp.notation.STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT;

import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.command.UnexecutableCommand;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;
import org.eclipse.uml2.common.edit.command.SubsetSupersetReplaceCommand;
import org.eclipse.uml2.common.edit.command.SubsetSupersetSetCommand;
import org.eclipse.uml2.common.edit.command.SupersetRemoveCommand;

import net.astah.dd.dc.Bounds;
import net.astah.dd.di.DIPackage;
import net.astah.dd.di.Diagram;
import net.astah.dd.di.edit.command.DiagramContext;
import net.astah.dd.di.edit.provider.LayoutCalculator;
import net.astah.emf.edit.ClippedFragment;
import net.astah.emf.edit.command.PasteCommand;
import net.astah.emf.edit.layout.LayoutManager;
import net.astah.golf.geom2D.Pnt2d;
import net.astah.notation.NotationFactory;
import net.astah.notation.NotationPackage;
import net.astah.notation.provider.DiagramItemProvider;
import net.astah.stpa.stamp.notation.STAMPDiagram;
import net.astah.stpa.stamp.notation.STAMPDiagramElement;
import net.astah.stpa.stamp.notation.STAMPNotationFactory;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;
import net.astah.stpa.stamp.notation.edit.command.InitializeSTAMPDiagramElementCommand;
import net.astah.stpa.stamp.notation.edit.layout.STAMPDiagramLayoutManager;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.notation.STAMPDiagram} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class STAMPDiagramItemProvider extends DiagramItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPDiagramItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addReferenceStylePropertyDescriptor(object);
            addSTAMPModelElementPropertyDescriptor(object);
            addSTAMPTargetEdgePropertyDescriptor(object);
            addSTAMPSourceEdgePropertyDescriptor(object);
            addOwnerPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Reference Style feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addReferenceStylePropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_DiagramElement_referenceStyle_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_DiagramElement_referenceStyle_feature", "_UI_DiagramElement_type"),
                 NotationPackage.Literals.DIAGRAM_ELEMENT__REFERENCE_STYLE,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the STAMP Model Element feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPModelElementPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPDiagramElement_STAMPModelElement_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPDiagramElement_STAMPModelElement_feature", "_UI_STAMPDiagramElement_type"),
                 STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_MODEL_ELEMENT,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the STAMP Target Edge feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPTargetEdgePropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPDiagramElement_STAMPTargetEdge_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPDiagramElement_STAMPTargetEdge_feature", "_UI_STAMPDiagramElement_type"),
                 STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_TARGET_EDGE,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the STAMP Source Edge feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPSourceEdgePropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPDiagramElement_STAMPSourceEdge_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPDiagramElement_STAMPSourceEdge_feature", "_UI_STAMPDiagramElement_type"),
                 STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_SOURCE_EDGE,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Owner feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addOwnerPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPDiagram_owner_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPDiagram_owner_feature", "_UI_STAMPDiagram_type"),
                 STAMPNotationPackage.Literals.STAMP_DIAGRAM__OWNER,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
        if (childrenFeatures == null) {
            super.getChildrenFeatures(object);
            childrenFeatures.add(STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT);
        }
        return childrenFeatures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child) {
        // Check the type of the specified child object and return the proper feature to use for
        // adding (see {@link AddCommand}) it as a child.

        return super.getChildFeature(object, child);
    }

    /**
     * This returns STAMPDiagram.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/STAMPDiagram"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((STAMPDiagram)object).getName();
        return label == null || label.length() == 0 ?
            getString("_UI_STAMPDiagram_type") :
            getString("_UI_STAMPDiagram_type") + " " + label;
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(STAMPDiagram.class)) {
            case STAMPNotationPackage.STAMP_DIAGRAM__STAMP_OWNED_ELEMENT:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPEdge()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPDiagram()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPLabel()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPCompartment()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPCompartmentableShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPComponentShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPGraphicalShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPControlStructureDiagram()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPControlLoopDiagram()));
    }

    /**
     * Return the resource locator for this item provider's resources.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator() {
        return STAMPNotationEditPlugin.INSTANCE;
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createRemoveCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.util.Collection)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createRemoveCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection) {
        if (feature == NotationPackage.Literals.DIAGRAM_ELEMENT__REFERENCE_STYLE) {
            return new SupersetRemoveCommand(domain, owner, feature, new EStructuralFeature[] {DIPackage.Literals.DIAGRAM_ELEMENT__SHARED_STYLE}, collection);
        }
        return super.createRemoveCommand(domain, owner, feature, collection);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createReplaceCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.lang.Object, java.util.Collection)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createReplaceCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Object value, Collection<?> collection) {
        if (feature == NotationPackage.Literals.DIAGRAM_ELEMENT__REFERENCE_STYLE) {
            return new SubsetSupersetReplaceCommand(domain, owner, feature, null, new EStructuralFeature[] {DIPackage.Literals.DIAGRAM_ELEMENT__SHARED_STYLE}, value, collection);
        }
        return super.createReplaceCommand(domain, owner, feature, value, collection);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createSetCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.lang.Object)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createSetCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Object value) {
        if (feature == DIPackage.Literals.DIAGRAM_ELEMENT__SHARED_STYLE) {
            return new SubsetSupersetSetCommand(domain, owner, feature, new EStructuralFeature[] {NotationPackage.Literals.DIAGRAM_ELEMENT__REFERENCE_STYLE}, null, value);
        }
        if (feature == NotationPackage.Literals.DIAGRAM_ELEMENT__REFERENCE_STYLE) {
            return new SubsetSupersetSetCommand(domain, owner, feature, null, new EStructuralFeature[] {DIPackage.Literals.DIAGRAM_ELEMENT__SHARED_STYLE}, value);
        }
        return super.createSetCommand(domain, owner, feature, value);
    }

    /**
     * @generated NOT
     */
    @Override
    protected Command createCreateChildCommand(EditingDomain domain,
            EObject owner,
            EStructuralFeature feature,
            Object value,
            int index,
            Collection<?> collection) {
        Command command =
                super.createCreateChildCommand(domain, owner, feature, value, index, collection);
        if (feature == DIPackage.Literals.DIAGRAM_ELEMENT__OWNED_ELEMENT) {
            command = new InitializeSTAMPDiagramElementCommand(domain, owner, value, index).chain(command);
        }
        return command;
    }

    @Override
    protected Command createPasteCommand(Object object, EditingDomain domain,
            CommandParameter commandParameter) {
        final Diagram diagram = (Diagram) object;
        final Object context = getContext(commandParameter);
        final Collection<?> collection = commandParameter.getCollection();
        final ClippedFragment fragment = getClippedFragment(collection);
        if ((fragment != null) && !isPastableFragment(fragment, diagram)) {
            return UnexecutableCommand.INSTANCE;
        }

        Command command = super.createPasteCommand(object, domain, commandParameter);
        if (!command.canExecute()) {
            command.dispose();

            // 図へのペーストを行えないので選択された図要素へのペーストを試行する
            final Collection<? extends EObject> selection = DiagramContext.getSelection(context);
            if (selection.size() != 1) {
                return UnexecutableCommand.INSTANCE;
            }
            final EObject owner = selection.iterator().next();
            command = PasteCommand.create(domain, context, owner, null, collection);
        }

        final List<?> presentations = collection.stream().filter(STAMPDiagramElement.class::isInstance)
                .collect(Collectors.toList());
        if (presentations.isEmpty()) {
            return command;
        }
        return createMoveTogetherCommand(domain, context, diagram, null, presentations)
                .chain(command);
    }

    @Override
    protected Command createAddCommand(EditingDomain domain, EObject owner,
            EStructuralFeature feature, Collection<?> collection, int index) {
        if (feature == STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT) {
            boolean existDiagram = collection.stream().anyMatch(obj -> obj instanceof Diagram);
            if (existDiagram) {
                return UnexecutableCommand.INSTANCE;
            }
        }
        return super.createAddCommand(domain, owner, feature, collection, index);
    }

    @Override
    public Object getMoveVector(EditingDomain domain, Object context, Object owner,
            Collection<?> targetObjects) {
        final Pnt2d location = getPasteLocation(context, targetObjects);
        if (location != null) {
            final Bounds bounds = new LayoutCalculator().getTotalBounds(targetObjects);
            if (bounds == null) {
                return NotationFactory.eINSTANCE.createVector(location.x, location.y);
            }
            return NotationFactory.eINSTANCE.createVector(location.x - bounds.getX(),
                    location.y - bounds.getY());
        }
        return null;
    }

    @Override
    public String getModelTreeText(final Object object) {
        final STAMPDiagram diagram = (STAMPDiagram) object;
        return diagram.getName();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    protected LayoutManager<STAMPDiagram> layoutManager;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    @Override
    protected LayoutManager<?> getLayoutManager(EditingDomain domain, Object object) {
        if (layoutManager == null) {
            layoutManager = new STAMPDiagramLayoutManager();
        }
        return layoutManager;
    }

}
