package net.astah.stpa.stamp.notation.editor;

import net.astah.golf.draw.GArrow;
import net.astah.golf.draw.GRimmedGeometry;
import net.astah.golf.geom2D.Pnt2d;
import net.astah.notation.editor.EdgeTransformer;
import net.astah.notation.editor.EdgeTransformer.MoveType;
import net.astah.notation.editor.IMovableViewElement;
import net.astah.notation.editor.IRepointableViewElement;
import net.astah.notation.editor.ITransformer;
import net.astah.stpa.stamp.notation.STAMPEdge;

/**
 * ノートアンカー要素を表示するためのビューエレメントを実装するクラスです。
 */
public class STAMPNoteAnchorViewElement extends STAMPEdgeViewElementImpl
        implements IMovableViewElement, IRepointableViewElement {

    public STAMPNoteAnchorViewElement(STAMPEdge model) {
        super(model);
    }

    @Override
    protected void update() {
        super.update();
        getLinePart().updateArrow(GArrow.END, GArrow.NONE);
        getLinePart().setRimPattern(GRimmedGeometry.DASH1, 5);

        getLinePart().updateColor();
    }

    @Override
    public ITransformer startMove(Pnt2d startLocation) {
        return new EdgeTransformer(this, startLocation, MoveType.MOVE);
    }

    @Override
    public ITransformer startRepoint(Pnt2d startLocation) {
        return new EdgeTransformer(this, startLocation, MoveType.REPOINT);
    }

}
