/**
 */
package net.astah.stpa.stamp.notation.util;

import org.eclipse.emf.ecore.EModelElement;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.Switch;

import net.astah.dd.di.Diagram;
import net.astah.dd.di.DiagramElement;
import net.astah.dd.di.Edge;
import net.astah.dd.di.Shape;
import net.astah.notation.GraphicalShape;
import net.astah.notation.TableView;
import net.astah.stpa.stamp.notation.*;
import net.astah.stpa.stamp.notation.AccidentHazardSafetyConstraintTable;
import net.astah.stpa.stamp.notation.CountermeasureTable;
import net.astah.stpa.stamp.notation.HCFSummeryTable;
import net.astah.stpa.stamp.notation.HCFTable;
import net.astah.stpa.stamp.notation.PreconditionTable;
import net.astah.stpa.stamp.notation.STAMPCompartment;
import net.astah.stpa.stamp.notation.STAMPCompartmentableShape;
import net.astah.stpa.stamp.notation.STAMPComponentShape;
import net.astah.stpa.stamp.notation.STAMPControlLoopDiagram;
import net.astah.stpa.stamp.notation.STAMPControlStructureDiagram;
import net.astah.stpa.stamp.notation.STAMPDiagram;
import net.astah.stpa.stamp.notation.STAMPDiagramElement;
import net.astah.stpa.stamp.notation.STAMPEdge;
import net.astah.stpa.stamp.notation.STAMPGraphicalShape;
import net.astah.stpa.stamp.notation.STAMPLabel;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;
import net.astah.stpa.stamp.notation.STAMPShape;
import net.astah.stpa.stamp.notation.STAMPTable;
import net.astah.stpa.stamp.notation.UCATable;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see net.astah.stpa.stamp.notation.STAMPNotationPackage
 * @generated
 */
public class STAMPNotationSwitch<T> extends Switch<T> {
    /**
     * The cached model package
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected static STAMPNotationPackage modelPackage;

    /**
     * Creates an instance of the switch.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPNotationSwitch() {
        if (modelPackage == null) {
            modelPackage = STAMPNotationPackage.eINSTANCE;
        }
    }

    /**
     * Checks whether this is a switch for the given package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param ePackage the package in question.
     * @return whether this is a switch for the given package.
     * @generated
     */
    @Override
    protected boolean isSwitchFor(EPackage ePackage) {
        return ePackage == modelPackage;
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
    @Override
    protected T doSwitch(int classifierID, EObject theEObject) {
        switch (classifierID) {
            case STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT: {
                STAMPDiagramElement stampDiagramElement = (STAMPDiagramElement)theEObject;
                T result = caseSTAMPDiagramElement(stampDiagramElement);
                if (result == null) result = caseNotation_DiagramElement(stampDiagramElement);
                if (result == null) result = caseDiagramElement(stampDiagramElement);
                if (result == null) result = caseEModelElement(stampDiagramElement);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.STAMP_EDGE: {
                STAMPEdge stampEdge = (STAMPEdge)theEObject;
                T result = caseSTAMPEdge(stampEdge);
                if (result == null) result = caseNotation_Edge(stampEdge);
                if (result == null) result = caseSTAMPDiagramElement(stampEdge);
                if (result == null) result = caseEdge(stampEdge);
                if (result == null) result = caseNotation_DiagramElement(stampEdge);
                if (result == null) result = caseDiagramElement(stampEdge);
                if (result == null) result = caseEModelElement(stampEdge);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.STAMP_DIAGRAM: {
                STAMPDiagram stampDiagram = (STAMPDiagram)theEObject;
                T result = caseSTAMPDiagram(stampDiagram);
                if (result == null) result = caseNotation_Diagram(stampDiagram);
                if (result == null) result = caseSTAMPDiagramElement(stampDiagram);
                if (result == null) result = caseDiagram(stampDiagram);
                if (result == null) result = caseNotation_DiagramElement(stampDiagram);
                if (result == null) result = caseShape(stampDiagram);
                if (result == null) result = caseDiagramElement(stampDiagram);
                if (result == null) result = caseEModelElement(stampDiagram);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.STAMP_SHAPE: {
                STAMPShape stampShape = (STAMPShape)theEObject;
                T result = caseSTAMPShape(stampShape);
                if (result == null) result = caseNotation_Shape(stampShape);
                if (result == null) result = caseSTAMPDiagramElement(stampShape);
                if (result == null) result = caseShape(stampShape);
                if (result == null) result = caseNotation_DiagramElement(stampShape);
                if (result == null) result = caseDiagramElement(stampShape);
                if (result == null) result = caseEModelElement(stampShape);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.STAMP_LABEL: {
                STAMPLabel stampLabel = (STAMPLabel)theEObject;
                T result = caseSTAMPLabel(stampLabel);
                if (result == null) result = caseSTAMPShape(stampLabel);
                if (result == null) result = caseNotation_Shape(stampLabel);
                if (result == null) result = caseSTAMPDiagramElement(stampLabel);
                if (result == null) result = caseShape(stampLabel);
                if (result == null) result = caseNotation_DiagramElement(stampLabel);
                if (result == null) result = caseDiagramElement(stampLabel);
                if (result == null) result = caseEModelElement(stampLabel);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.STAMP_COMPARTMENT: {
                STAMPCompartment stampCompartment = (STAMPCompartment)theEObject;
                T result = caseSTAMPCompartment(stampCompartment);
                if (result == null) result = caseSTAMPDiagramElement(stampCompartment);
                if (result == null) result = caseNotation_DiagramElement(stampCompartment);
                if (result == null) result = caseDiagramElement(stampCompartment);
                if (result == null) result = caseEModelElement(stampCompartment);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.STAMP_COMPARTMENTABLE_SHAPE: {
                STAMPCompartmentableShape stampCompartmentableShape = (STAMPCompartmentableShape)theEObject;
                T result = caseSTAMPCompartmentableShape(stampCompartmentableShape);
                if (result == null) result = caseSTAMPShape(stampCompartmentableShape);
                if (result == null) result = caseNotation_Shape(stampCompartmentableShape);
                if (result == null) result = caseSTAMPDiagramElement(stampCompartmentableShape);
                if (result == null) result = caseShape(stampCompartmentableShape);
                if (result == null) result = caseNotation_DiagramElement(stampCompartmentableShape);
                if (result == null) result = caseDiagramElement(stampCompartmentableShape);
                if (result == null) result = caseEModelElement(stampCompartmentableShape);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.STAMP_COMPONENT_SHAPE: {
                STAMPComponentShape stampComponentShape = (STAMPComponentShape)theEObject;
                T result = caseSTAMPComponentShape(stampComponentShape);
                if (result == null) result = caseSTAMPCompartmentableShape(stampComponentShape);
                if (result == null) result = caseSTAMPShape(stampComponentShape);
                if (result == null) result = caseNotation_Shape(stampComponentShape);
                if (result == null) result = caseSTAMPDiagramElement(stampComponentShape);
                if (result == null) result = caseShape(stampComponentShape);
                if (result == null) result = caseNotation_DiagramElement(stampComponentShape);
                if (result == null) result = caseDiagramElement(stampComponentShape);
                if (result == null) result = caseEModelElement(stampComponentShape);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.STAMP_GRAPHICAL_SHAPE: {
                STAMPGraphicalShape stampGraphicalShape = (STAMPGraphicalShape)theEObject;
                T result = caseSTAMPGraphicalShape(stampGraphicalShape);
                if (result == null) result = caseGraphicalShape(stampGraphicalShape);
                if (result == null) result = caseSTAMPShape(stampGraphicalShape);
                if (result == null) result = caseNotation_Shape(stampGraphicalShape);
                if (result == null) result = caseSTAMPDiagramElement(stampGraphicalShape);
                if (result == null) result = caseShape(stampGraphicalShape);
                if (result == null) result = caseNotation_DiagramElement(stampGraphicalShape);
                if (result == null) result = caseDiagramElement(stampGraphicalShape);
                if (result == null) result = caseEModelElement(stampGraphicalShape);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.STAMP_CONTROL_STRUCTURE_DIAGRAM: {
                STAMPControlStructureDiagram stampControlStructureDiagram = (STAMPControlStructureDiagram)theEObject;
                T result = caseSTAMPControlStructureDiagram(stampControlStructureDiagram);
                if (result == null) result = caseSTAMPDiagram(stampControlStructureDiagram);
                if (result == null) result = caseNotation_Diagram(stampControlStructureDiagram);
                if (result == null) result = caseSTAMPDiagramElement(stampControlStructureDiagram);
                if (result == null) result = caseDiagram(stampControlStructureDiagram);
                if (result == null) result = caseNotation_DiagramElement(stampControlStructureDiagram);
                if (result == null) result = caseShape(stampControlStructureDiagram);
                if (result == null) result = caseDiagramElement(stampControlStructureDiagram);
                if (result == null) result = caseEModelElement(stampControlStructureDiagram);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.COMPONENT_EXTRACTING_TABLE: {
                ComponentExtractingTable componentExtractingTable = (ComponentExtractingTable)theEObject;
                T result = caseComponentExtractingTable(componentExtractingTable);
                if (result == null) result = caseSTAMPTable(componentExtractingTable);
                if (result == null) result = caseTableView(componentExtractingTable);
                if (result == null) result = caseNotation_Diagram(componentExtractingTable);
                if (result == null) result = caseDiagram(componentExtractingTable);
                if (result == null) result = caseShape(componentExtractingTable);
                if (result == null) result = caseDiagramElement(componentExtractingTable);
                if (result == null) result = caseEModelElement(componentExtractingTable);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.STAMP_TABLE: {
                STAMPTable stampTable = (STAMPTable)theEObject;
                T result = caseSTAMPTable(stampTable);
                if (result == null) result = caseTableView(stampTable);
                if (result == null) result = caseNotation_Diagram(stampTable);
                if (result == null) result = caseDiagram(stampTable);
                if (result == null) result = caseShape(stampTable);
                if (result == null) result = caseDiagramElement(stampTable);
                if (result == null) result = caseEModelElement(stampTable);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.STAMP_CONTROL_LOOP_DIAGRAM: {
                STAMPControlLoopDiagram stampControlLoopDiagram = (STAMPControlLoopDiagram)theEObject;
                T result = caseSTAMPControlLoopDiagram(stampControlLoopDiagram);
                if (result == null) result = caseSTAMPDiagram(stampControlLoopDiagram);
                if (result == null) result = caseNotation_Diagram(stampControlLoopDiagram);
                if (result == null) result = caseSTAMPDiagramElement(stampControlLoopDiagram);
                if (result == null) result = caseDiagram(stampControlLoopDiagram);
                if (result == null) result = caseNotation_DiagramElement(stampControlLoopDiagram);
                if (result == null) result = caseShape(stampControlLoopDiagram);
                if (result == null) result = caseDiagramElement(stampControlLoopDiagram);
                if (result == null) result = caseEModelElement(stampControlLoopDiagram);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.PRECONDITION_TABLE: {
                PreconditionTable preconditionTable = (PreconditionTable)theEObject;
                T result = casePreconditionTable(preconditionTable);
                if (result == null) result = caseSTAMPTable(preconditionTable);
                if (result == null) result = caseTableView(preconditionTable);
                if (result == null) result = caseNotation_Diagram(preconditionTable);
                if (result == null) result = caseDiagram(preconditionTable);
                if (result == null) result = caseShape(preconditionTable);
                if (result == null) result = caseDiagramElement(preconditionTable);
                if (result == null) result = caseEModelElement(preconditionTable);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.ACCIDENT_HAZARD_SAFETY_CONSTRAINT_TABLE: {
                AccidentHazardSafetyConstraintTable accidentHazardSafetyConstraintTable = (AccidentHazardSafetyConstraintTable)theEObject;
                T result = caseAccidentHazardSafetyConstraintTable(accidentHazardSafetyConstraintTable);
                if (result == null) result = caseSTAMPTable(accidentHazardSafetyConstraintTable);
                if (result == null) result = caseTableView(accidentHazardSafetyConstraintTable);
                if (result == null) result = caseNotation_Diagram(accidentHazardSafetyConstraintTable);
                if (result == null) result = caseDiagram(accidentHazardSafetyConstraintTable);
                if (result == null) result = caseShape(accidentHazardSafetyConstraintTable);
                if (result == null) result = caseDiagramElement(accidentHazardSafetyConstraintTable);
                if (result == null) result = caseEModelElement(accidentHazardSafetyConstraintTable);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.UCA_TABLE: {
                UCATable ucaTable = (UCATable)theEObject;
                T result = caseUCATable(ucaTable);
                if (result == null) result = caseSTAMPTable(ucaTable);
                if (result == null) result = caseTableView(ucaTable);
                if (result == null) result = caseNotation_Diagram(ucaTable);
                if (result == null) result = caseDiagram(ucaTable);
                if (result == null) result = caseShape(ucaTable);
                if (result == null) result = caseDiagramElement(ucaTable);
                if (result == null) result = caseEModelElement(ucaTable);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.HCF_TABLE: {
                HCFTable hcfTable = (HCFTable)theEObject;
                T result = caseHCFTable(hcfTable);
                if (result == null) result = caseSTAMPTable(hcfTable);
                if (result == null) result = caseTableView(hcfTable);
                if (result == null) result = caseNotation_Diagram(hcfTable);
                if (result == null) result = caseDiagram(hcfTable);
                if (result == null) result = caseShape(hcfTable);
                if (result == null) result = caseDiagramElement(hcfTable);
                if (result == null) result = caseEModelElement(hcfTable);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.HCF_SUMMERY_TABLE: {
                HCFSummeryTable hcfSummeryTable = (HCFSummeryTable)theEObject;
                T result = caseHCFSummeryTable(hcfSummeryTable);
                if (result == null) result = caseSTAMPTable(hcfSummeryTable);
                if (result == null) result = caseTableView(hcfSummeryTable);
                if (result == null) result = caseNotation_Diagram(hcfSummeryTable);
                if (result == null) result = caseDiagram(hcfSummeryTable);
                if (result == null) result = caseShape(hcfSummeryTable);
                if (result == null) result = caseDiagramElement(hcfSummeryTable);
                if (result == null) result = caseEModelElement(hcfSummeryTable);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case STAMPNotationPackage.COUNTERMEASURE_TABLE: {
                CountermeasureTable countermeasureTable = (CountermeasureTable)theEObject;
                T result = caseCountermeasureTable(countermeasureTable);
                if (result == null) result = caseSTAMPTable(countermeasureTable);
                if (result == null) result = caseTableView(countermeasureTable);
                if (result == null) result = caseNotation_Diagram(countermeasureTable);
                if (result == null) result = caseDiagram(countermeasureTable);
                if (result == null) result = caseShape(countermeasureTable);
                if (result == null) result = caseDiagramElement(countermeasureTable);
                if (result == null) result = caseEModelElement(countermeasureTable);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            default: return defaultCase(theEObject);
        }
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>STAMP Diagram Element</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>STAMP Diagram Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSTAMPDiagramElement(STAMPDiagramElement object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>STAMP Edge</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>STAMP Edge</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSTAMPEdge(STAMPEdge object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>STAMP Diagram</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>STAMP Diagram</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSTAMPDiagram(STAMPDiagram object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>STAMP Shape</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>STAMP Shape</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSTAMPShape(STAMPShape object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>STAMP Label</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>STAMP Label</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSTAMPLabel(STAMPLabel object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>STAMP Compartment</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>STAMP Compartment</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSTAMPCompartment(STAMPCompartment object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>STAMP Compartmentable Shape</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>STAMP Compartmentable Shape</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSTAMPCompartmentableShape(STAMPCompartmentableShape object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>STAMP Control Structure Diagram</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>STAMP Control Structure Diagram</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSTAMPControlStructureDiagram(STAMPControlStructureDiagram object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Component Extracting Table</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Component Extracting Table</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseComponentExtractingTable(ComponentExtractingTable object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>STAMP Graphical Shape</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>STAMP Graphical Shape</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSTAMPGraphicalShape(STAMPGraphicalShape object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Precondition Table</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Precondition Table</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T casePreconditionTable(PreconditionTable object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>STAMP Table</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>STAMP Table</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSTAMPTable(STAMPTable object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Accident Hazard Safety Constraint Table</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Accident Hazard Safety Constraint Table</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseAccidentHazardSafetyConstraintTable(AccidentHazardSafetyConstraintTable object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>UCA Table</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>UCA Table</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseUCATable(UCATable object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>STAMP Control Loop Diagram</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>STAMP Control Loop Diagram</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSTAMPControlLoopDiagram(STAMPControlLoopDiagram object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>HCF Summery Table</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>HCF Summery Table</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseHCFSummeryTable(HCFSummeryTable object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>HCF Table</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>HCF Table</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseHCFTable(HCFTable object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Countermeasure Table</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Countermeasure Table</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseCountermeasureTable(CountermeasureTable object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>STAMP Component Shape</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>STAMP Component Shape</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSTAMPComponentShape(STAMPComponentShape object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>EModel Element</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>EModel Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseEModelElement(EModelElement object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Diagram Element</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Diagram Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseDiagramElement(DiagramElement object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Edge</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Edge</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseEdge(Edge object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Diagram Element</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Diagram Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseNotation_DiagramElement(net.astah.notation.DiagramElement object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Edge</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Edge</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseNotation_Edge(net.astah.notation.Edge object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Shape</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Shape</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseShape(Shape object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Diagram</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Diagram</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseDiagram(Diagram object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Shape</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Shape</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseNotation_Shape(net.astah.notation.Shape object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Graphical Shape</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Graphical Shape</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseGraphicalShape(GraphicalShape object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Diagram</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Diagram</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseNotation_Diagram(net.astah.notation.Diagram object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Table View</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Table View</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseTableView(TableView object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch, but this is the last case anyway.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject)
     * @generated
     */
    @Override
    public T defaultCase(EObject object) {
        return null;
    }

} //STAMPNotationSwitch
