package net.astah.stpa.stamp.ui.menu.handler;

import java.awt.event.ActionEvent;
import java.util.List;

import net.astah.golf.widget.ISelection;
import net.astah.jomt.jcontrol.ZoomOutViewCommand;
import net.astah.stpa.stamp.notation.STAMPControlLoopDiagram;
import net.astah.stpa.stamp.notation.STAMPControlStructureDiagram;
import net.astah.ui.menu.annotation.Execute;
import net.astah.ui.menu.annotation.Handler;
import net.astah.ui.menu.annotation.KeyBinding;
import net.astah.ui.menu.annotation.MenuCommand;
import net.astah.ui.menu.annotation.MenuItem;
import net.astah.ui.menu.annotation.MenuItem.ItemKind;

/**
 * 図の表示を縮小します。
 */
@Handler(targets = { STAMPControlStructureDiagram.class,
        STAMPControlLoopDiagram.class })
@MenuItem(label = "%StampControlStructureDiagram_zoom_out_label",
        iconURI = "platform:/plugin/net.astah.core.app/net/astah/jomt/resource/images/zoomout.png",
        tooltip = "%StampControlStructureDiagram_zoom_out_tooltip",
        type = ItemKind.PUSH)
@MenuCommand(id = "stpa.ZoomOutViewCommand",
        category = "edit.zoom")
@KeyBinding(keySequence = "control CLOSE_BRACKET")
public class ZoomOutViewHandler {

    /**
     * 図の表示を縮小するコマンドを実行します。
     * 
     * @param selection
     *            選択要素
     * @param params
     *            コマンドのパラメータ
     * @param e
     *            アクションイベント
     */
    @Execute
    public void execute(final ISelection selection, final List<String> params,
            final ActionEvent e) {
        final ZoomOutViewCommand command = new ZoomOutViewCommand();
        command.setUseTransaction(true);
        command.execute();
    }
}