package net.astah.stpa.stamp.ui.table;

import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;

import net.astah.emf.edit.provider.swing.AdapterFactoryStyledLabelProvider;
import net.astah.golf.view.swing.IPropertySourceProvider;
import net.astah.golf.view.swing.MultiValueTableCellRenderer;

/**
 * 対策表の各項目を表示するための{@link TableCellRenderer} と{@link TableCellEditor} を提供するクラスです。
 */
public class CountermeasureTableColumnProvider extends STPAGenericTableColumnProvider {

    @Override
    protected TableCellRenderer createCellRenderer(
            final TuplePropertyColumnDescriptor columnDescriptor,
            final IPropertySourceProvider propertySourceProvider) {
        return new MultiValueTableCellRenderer(columnDescriptor, propertySourceProvider,
                new AdapterFactoryStyledLabelProvider(getAdapterFactory()));
    }

    @Override
    protected TableCellEditor createCellEditor(final TuplePropertyColumnDescriptor columnDescriptor,
            final IPropertySourceProvider propertySourceProvider) {
        final ColumnCellEditor columnCellEditor = new ColumnCellEditor(columnDescriptor,
                propertySourceProvider);
        columnCellEditor.setClickCountToStart(2);
        return columnCellEditor;
    }
}
