package net.astah.stpa.stamp.ui.table;

import java.util.Comparator;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;

import net.astah.emf.edit.provider.ItemProviders;
import net.astah.stpa.stamp.HazardCausalFactor;
import net.astah.table.CellDescriptor;
import net.astah.table.ICellEvaluator;
import net.astah.table.Tuple;

/**
 * HCF表のシナリオ列を表示するための{@link IItemPropertyDescriptor} を定義したクラスです。
 */
public class HCFScenarioCellEvaluator implements ICellEvaluator {

    @Override
    public Object getElement(final CellDescriptor cellDescriptor, final Tuple tuple) {
        return null;
    }

    @Override
    public IItemPropertyDescriptor getHeaderPropertyDescriptor(final CellDescriptor cellDescriptor,
            final Tuple tuple) {
        return null;
    }

    @Override
    public IItemPropertyDescriptor getCellPropertyDescriptor(final CellDescriptor cellDescriptor,
            final Tuple rowTuple, final Tuple columnTuple) {
        final EObject eObject = rowTuple.getElements().get(0).getObject();
        if (!(eObject instanceof HazardCausalFactor)) {
            return null;
        }
        final HazardCausalFactor hcf = (HazardCausalFactor) eObject;
        final AdapterFactory adapterFactory = ItemProviders.getAdapterFactory(hcf);
        return new HCFScenarioPropertyDescriptor(adapterFactory, "", "", null, hcf);
    }

    @Override
    public Comparator<?> getComparator(final CellDescriptor cellDescriptor) {
        return null;
    }

    /**
     * HCF表のシナリオプロパティの取得用{@link ItemPropertyDescriptor} です。
     */
    class HCFScenarioPropertyDescriptor extends ItemPropertyDescriptor {

        private final HazardCausalFactor hcf;

        public HCFScenarioPropertyDescriptor(final AdapterFactory adapterFactory,
                final String displayName, final String description,
                final EReference[] parentReferences, final HazardCausalFactor hcf) {
            super(adapterFactory, displayName, description, parentReferences);
            this.hcf = hcf;
        }

        @Override
        public Object getPropertyValue(final Object object) {
            return hcf.getHazardScenarios();
        }
    }
}