/**
 */
package net.astah.stpa.stamp;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Control Structure</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link net.astah.stpa.stamp.ControlStructure#getComponents <em>Component</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.ControlStructure#getLinks <em>Link</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.ControlStructure#getLinkEnds <em>Link End</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.ControlStructure#getOwner <em>Owner</em>}</li>
 * </ul>
 *
 * @see net.astah.stpa.stamp.STAMPPackage#getControlStructure()
 * @model
 * @generated
 */
public interface ControlStructure extends NamedElement {
    /**
     * Returns the value of the '<em><b>Link</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.Link}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.Link#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Link</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Link</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getControlStructure_Link()
     * @see net.astah.stpa.stamp.Link#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true"
     * @generated
     */
    EList<Link> getLinks();

    /**
     * Creates a new {@link net.astah.stpa.stamp.Link} and appends it to the '<em><b>Link</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param eClass The Ecore class of the {@link net.astah.stpa.stamp.Link} to create.
     * @return The new {@link net.astah.stpa.stamp.Link}.
     * @see #getLinks()
     * @generated
     */
    Link createLink(EClass eClass);

    /**
     * Returns the value of the '<em><b>Component</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.Component}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.Component#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Component</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Component</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getControlStructure_Component()
     * @see net.astah.stpa.stamp.Component#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true"
     * @generated
     */
    EList<Component> getComponents();

    /**
     * Creates a new {@link net.astah.stpa.stamp.Component} and appends it to the '<em><b>Component</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.Component}.
     * @see #getComponents()
     * @generated
     */
    Component createComponent();

    /**
     * Returns the value of the '<em><b>Owner</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.STPAAnalysis#getControlStructures <em>Control Structure</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Owner</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Owner</em>' container reference.
     * @see #setOwner(STPAAnalysis)
     * @see net.astah.stpa.stamp.STAMPPackage#getControlStructure_Owner()
     * @see net.astah.stpa.stamp.STPAAnalysis#getControlStructures
     * @model opposite="controlStructure" required="true" transient="false" ordered="false"
     * @generated
     */
    STPAAnalysis getOwner();

    /**
     * Sets the value of the '{@link net.astah.stpa.stamp.ControlStructure#getOwner <em>Owner</em>}' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Owner</em>' container reference.
     * @see #getOwner()
     * @generated
     */
    void setOwner(STPAAnalysis value);

    /**
     * Returns the value of the '<em><b>Link End</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.LinkEnd}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.LinkEnd#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Link End</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Link End</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getControlStructure_LinkEnd()
     * @see net.astah.stpa.stamp.LinkEnd#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true"
     * @generated
     */
    EList<LinkEnd> getLinkEnds();

    /**
     * Creates a new {@link net.astah.stpa.stamp.LinkEnd} and appends it to the '<em><b>Link End</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.LinkEnd}.
     * @see #getLinkEnds()
     * @generated
     */
    LinkEnd createLinkEnd();

} // ControlStructure
