/**
 */
package net.astah.stpa.stamp;

import org.eclipse.emf.common.util.EList;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Countermeasure</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link net.astah.stpa.stamp.Countermeasure#getTargetComponents <em>Target Component</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.Countermeasure#getHazardCausalFactors <em>Hazard Causal Factor</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.Countermeasure#getRemarks <em>Remarks</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.Countermeasure#getOwner <em>Owner</em>}</li>
 * </ul>
 *
 * @see net.astah.stpa.stamp.STAMPPackage#getCountermeasure()
 * @model
 * @generated
 */
public interface Countermeasure extends IdentifiedElement {

    /**
     * Returns the value of the '<em><b>Target Component</b></em>' reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.Component}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Target Component</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Target Component</em>' reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getCountermeasure_TargetComponent()
     * @model
     * @generated
     */
    EList<Component> getTargetComponents();

    /**
     * Returns the value of the '<em><b>Hazard Causal Factor</b></em>' reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.HazardCausalFactor}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.HazardCausalFactor#getCountermeasures <em>Countermeasure</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Hazard Causal Factor</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Hazard Causal Factor</em>' reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getCountermeasure_HazardCausalFactor()
     * @see net.astah.stpa.stamp.HazardCausalFactor#getCountermeasures
     * @model opposite="countermeasure" required="true"
     * @generated
     */
    EList<HazardCausalFactor> getHazardCausalFactors();

    /**
     * Returns the value of the '<em><b>Remarks</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Remarks</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Remarks</em>' attribute.
     * @see #setRemarks(String)
     * @see net.astah.stpa.stamp.STAMPPackage#getCountermeasure_Remarks()
     * @model ordered="false"
     * @generated
     */
    String getRemarks();

    /**
     * Sets the value of the '{@link net.astah.stpa.stamp.Countermeasure#getRemarks <em>Remarks</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Remarks</em>' attribute.
     * @see #getRemarks()
     * @generated
     */
    void setRemarks(String value);

    /**
     * Returns the value of the '<em><b>Owner</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.STPAAnalysis#getCountermeasures <em>Countermeasure</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Owner</em>' container reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Owner</em>' container reference.
     * @see #setOwner(STPAAnalysis)
     * @see net.astah.stpa.stamp.STAMPPackage#getCountermeasure_Owner()
     * @see net.astah.stpa.stamp.STPAAnalysis#getCountermeasures
     * @model opposite="countermeasure" required="true" transient="false" ordered="false"
     * @generated
     */
    STPAAnalysis getOwner();

    /**
     * Sets the value of the '{@link net.astah.stpa.stamp.Countermeasure#getOwner <em>Owner</em>}' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Owner</em>' container reference.
     * @see #getOwner()
     * @generated
     */
    void setOwner(STPAAnalysis value);
} // Countermeasure
