/**
 */
package net.astah.stpa.stamp.impl;

import java.util.Collection;

import net.astah.stpa.stamp.Countermeasure;
import net.astah.stpa.stamp.HazardCausalFactor;
import net.astah.stpa.stamp.HazardScenario;
import net.astah.stpa.stamp.Note;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.STPAAnalysis;
import net.astah.stpa.stamp.UnsafeControlAction;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hazard Causal Factor</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link net.astah.stpa.stamp.impl.HazardCausalFactorImpl#getOwner <em>Owner</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.HazardCausalFactorImpl#getHazardScenarios <em>Hazard Scenario</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.HazardCausalFactorImpl#getUnsafeControlAction <em>Unsafe Control Action</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.HazardCausalFactorImpl#getCountermeasures <em>Countermeasure</em>}</li>
 * </ul>
 *
 * @generated
 */
public class HazardCausalFactorImpl extends IdentifiedElementImpl implements HazardCausalFactor {
    /**
     * The cached value of the '{@link #getHazardScenarios() <em>Hazard Scenario</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getHazardScenarios()
     * @generated
     * @ordered
     */
    protected EList<HazardScenario> hazardScenarios;
    /**
     * The cached value of the '{@link #getUnsafeControlAction() <em>Unsafe Control Action</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getUnsafeControlAction()
     * @generated
     * @ordered
     */
    protected UnsafeControlAction unsafeControlAction;

    /**
     * The cached value of the '{@link #getCountermeasures() <em>Countermeasure</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getCountermeasures()
     * @generated
     * @ordered
     */
    protected EList<Countermeasure> countermeasures;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HazardCausalFactorImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return STAMPPackage.Literals.HAZARD_CAUSAL_FACTOR;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UnsafeControlAction getUnsafeControlAction() {
        if (unsafeControlAction != null && unsafeControlAction.eIsProxy()) {
            InternalEObject oldUnsafeControlAction = (InternalEObject)unsafeControlAction;
            unsafeControlAction = (UnsafeControlAction)eResolveProxy(oldUnsafeControlAction);
            if (unsafeControlAction != oldUnsafeControlAction) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, STAMPPackage.HAZARD_CAUSAL_FACTOR__UNSAFE_CONTROL_ACTION, oldUnsafeControlAction, unsafeControlAction));
            }
        }
        return unsafeControlAction;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UnsafeControlAction basicGetUnsafeControlAction() {
        return unsafeControlAction;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setUnsafeControlAction(UnsafeControlAction newUnsafeControlAction) {
        UnsafeControlAction oldUnsafeControlAction = unsafeControlAction;
        unsafeControlAction = newUnsafeControlAction;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPPackage.HAZARD_CAUSAL_FACTOR__UNSAFE_CONTROL_ACTION, oldUnsafeControlAction, unsafeControlAction));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<Countermeasure> getCountermeasures() {
        if (countermeasures == null) {
            countermeasures = new EObjectWithInverseResolvingEList.ManyInverse<Countermeasure>(Countermeasure.class, this, STAMPPackage.HAZARD_CAUSAL_FACTOR__COUNTERMEASURE, STAMPPackage.COUNTERMEASURE__HAZARD_CAUSAL_FACTOR);
        }
        return countermeasures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STPAAnalysis getOwner() {
        if (eContainerFeatureID() != STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNER) return null;
        return (STPAAnalysis)eContainer();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STPAAnalysis basicGetOwner() {
        if (eContainerFeatureID() != STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNER) return null;
        return (STPAAnalysis)eInternalContainer();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetOwner(STPAAnalysis newOwner, NotificationChain msgs) {
        msgs = eBasicSetContainer((InternalEObject)newOwner, STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNER, msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setOwner(STPAAnalysis newOwner) {
        if (newOwner != eInternalContainer() || (eContainerFeatureID() != STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNER && newOwner != null)) {
            if (EcoreUtil.isAncestor(this, newOwner))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newOwner != null)
                msgs = ((InternalEObject)newOwner).eInverseAdd(this, STAMPPackage.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR, STPAAnalysis.class, msgs);
            msgs = basicSetOwner(newOwner, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNER, newOwner, newOwner));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<HazardScenario> getHazardScenarios() {
        if (hazardScenarios == null) {
            hazardScenarios = new EObjectContainmentEList.Resolving<HazardScenario>(HazardScenario.class, this, STAMPPackage.HAZARD_CAUSAL_FACTOR__HAZARD_SCENARIO);
        }
        return hazardScenarios;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public HazardScenario createHazardScenario() {
        HazardScenario newHazardScenario = (HazardScenario) create(STAMPPackage.Literals.HAZARD_SCENARIO);
        getHazardScenarios().add(newHazardScenario);
        return newHazardScenario;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__EANNOTATIONS:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getEAnnotations()).basicAdd(otherEnd, msgs);
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNED_NOTE:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getOwnedNotes()).basicAdd(otherEnd, msgs);
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNER:
                if (eInternalContainer() != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return basicSetOwner((STPAAnalysis)otherEnd, msgs);
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__COUNTERMEASURE:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getCountermeasures()).basicAdd(otherEnd, msgs);
        }
        return eDynamicInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__EANNOTATIONS:
                return ((InternalEList<?>)getEAnnotations()).basicRemove(otherEnd, msgs);
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNED_NOTE:
                return ((InternalEList<?>)getOwnedNotes()).basicRemove(otherEnd, msgs);
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNER:
                return basicSetOwner(null, msgs);
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__HAZARD_SCENARIO:
                return ((InternalEList<?>)getHazardScenarios()).basicRemove(otherEnd, msgs);
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__COUNTERMEASURE:
                return ((InternalEList<?>)getCountermeasures()).basicRemove(otherEnd, msgs);
        }
        return eDynamicInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
        switch (eContainerFeatureID()) {
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNER:
                return eInternalContainer().eInverseRemove(this, STAMPPackage.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR, STPAAnalysis.class, msgs);
        }
        return eDynamicBasicRemoveFromContainer(msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__EANNOTATIONS:
                return getEAnnotations();
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNED_NOTE:
                return getOwnedNotes();
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__ID:
                return getId();
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__DESCRIPTION:
                return getDescription();
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNER:
                if (resolve) return getOwner();
                return basicGetOwner();
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__HAZARD_SCENARIO:
                return getHazardScenarios();
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__UNSAFE_CONTROL_ACTION:
                if (resolve) return getUnsafeControlAction();
                return basicGetUnsafeControlAction();
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__COUNTERMEASURE:
                return getCountermeasures();
        }
        return eDynamicGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__EANNOTATIONS:
                getEAnnotations().clear();
                getEAnnotations().addAll((Collection<? extends EAnnotation>)newValue);
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNED_NOTE:
                getOwnedNotes().clear();
                getOwnedNotes().addAll((Collection<? extends Note>)newValue);
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__ID:
                setId((String)newValue);
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__DESCRIPTION:
                setDescription((String)newValue);
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNER:
                setOwner((STPAAnalysis)newValue);
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__HAZARD_SCENARIO:
                getHazardScenarios().clear();
                getHazardScenarios().addAll((Collection<? extends HazardScenario>)newValue);
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__UNSAFE_CONTROL_ACTION:
                setUnsafeControlAction((UnsafeControlAction)newValue);
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__COUNTERMEASURE:
                getCountermeasures().clear();
                getCountermeasures().addAll((Collection<? extends Countermeasure>)newValue);
                return;
        }
        eDynamicSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__EANNOTATIONS:
                getEAnnotations().clear();
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNED_NOTE:
                getOwnedNotes().clear();
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__ID:
                setId(ID_EDEFAULT);
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__DESCRIPTION:
                setDescription(DESCRIPTION_EDEFAULT);
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNER:
                setOwner((STPAAnalysis)null);
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__HAZARD_SCENARIO:
                getHazardScenarios().clear();
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__UNSAFE_CONTROL_ACTION:
                setUnsafeControlAction((UnsafeControlAction)null);
                return;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__COUNTERMEASURE:
                getCountermeasures().clear();
                return;
        }
        eDynamicUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__EANNOTATIONS:
                return eAnnotations != null && !eAnnotations.isEmpty();
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNED_NOTE:
                return ownedNotes != null && !ownedNotes.isEmpty();
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__ID:
                return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__DESCRIPTION:
                return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNER:
                return basicGetOwner() != null;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__HAZARD_SCENARIO:
                return hazardScenarios != null && !hazardScenarios.isEmpty();
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__UNSAFE_CONTROL_ACTION:
                return unsafeControlAction != null;
            case STAMPPackage.HAZARD_CAUSAL_FACTOR__COUNTERMEASURE:
                return countermeasures != null && !countermeasures.isEmpty();
        }
        return eDynamicIsSet(featureID);
    }

} //HazardCausalFactorImpl
