/**
 */
package net.astah.stpa.stamp.impl;

import java.util.Collection;

import net.astah.stpa.stamp.ControlAction;
import net.astah.stpa.stamp.Note;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.STPAAnalysis;
import net.astah.stpa.stamp.SafetyConstraint;
import net.astah.stpa.stamp.UnsafeControlAction;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Unsafe Control Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link net.astah.stpa.stamp.impl.UnsafeControlActionImpl#getControlAction <em>Control Action</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.UnsafeControlActionImpl#getViolatingSafetyConstraints <em>Violating Safety Constraint</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.UnsafeControlActionImpl#getOwner <em>Owner</em>}</li>
 * </ul>
 *
 * @generated
 */
public class UnsafeControlActionImpl extends IdentifiedElementImpl implements UnsafeControlAction {
    /**
     * The cached value of the '{@link #getControlAction() <em>Control Action</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getControlAction()
     * @generated
     * @ordered
     */
    protected ControlAction controlAction;

    /**
     * The cached value of the '{@link #getViolatingSafetyConstraints() <em>Violating Safety Constraint</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getViolatingSafetyConstraints()
     * @generated
     * @ordered
     */
    protected EList<SafetyConstraint> violatingSafetyConstraints;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected UnsafeControlActionImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return STAMPPackage.Literals.UNSAFE_CONTROL_ACTION;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ControlAction getControlAction() {
        if (controlAction != null && controlAction.eIsProxy()) {
            InternalEObject oldControlAction = (InternalEObject)controlAction;
            controlAction = (ControlAction)eResolveProxy(oldControlAction);
            if (controlAction != oldControlAction) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, STAMPPackage.UNSAFE_CONTROL_ACTION__CONTROL_ACTION, oldControlAction, controlAction));
            }
        }
        return controlAction;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ControlAction basicGetControlAction() {
        return controlAction;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setControlAction(ControlAction newControlAction) {
        ControlAction oldControlAction = controlAction;
        controlAction = newControlAction;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPPackage.UNSAFE_CONTROL_ACTION__CONTROL_ACTION, oldControlAction, controlAction));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<SafetyConstraint> getViolatingSafetyConstraints() {
        if (violatingSafetyConstraints == null) {
            violatingSafetyConstraints = new EObjectResolvingEList<SafetyConstraint>(SafetyConstraint.class, this, STAMPPackage.UNSAFE_CONTROL_ACTION__VIOLATING_SAFETY_CONSTRAINT);
        }
        return violatingSafetyConstraints;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STPAAnalysis getOwner() {
        if (eContainerFeatureID() != STAMPPackage.UNSAFE_CONTROL_ACTION__OWNER) return null;
        return (STPAAnalysis)eContainer();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STPAAnalysis basicGetOwner() {
        if (eContainerFeatureID() != STAMPPackage.UNSAFE_CONTROL_ACTION__OWNER) return null;
        return (STPAAnalysis)eInternalContainer();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetOwner(STPAAnalysis newOwner, NotificationChain msgs) {
        msgs = eBasicSetContainer((InternalEObject)newOwner, STAMPPackage.UNSAFE_CONTROL_ACTION__OWNER, msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setOwner(STPAAnalysis newOwner) {
        if (newOwner != eInternalContainer() || (eContainerFeatureID() != STAMPPackage.UNSAFE_CONTROL_ACTION__OWNER && newOwner != null)) {
            if (EcoreUtil.isAncestor(this, newOwner))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newOwner != null)
                msgs = ((InternalEObject)newOwner).eInverseAdd(this, STAMPPackage.STPA_ANALYSIS__UNSAFE_CONTROL_ACTION, STPAAnalysis.class, msgs);
            msgs = basicSetOwner(newOwner, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPPackage.UNSAFE_CONTROL_ACTION__OWNER, newOwner, newOwner));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPPackage.UNSAFE_CONTROL_ACTION__EANNOTATIONS:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getEAnnotations()).basicAdd(otherEnd, msgs);
            case STAMPPackage.UNSAFE_CONTROL_ACTION__OWNED_NOTE:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getOwnedNotes()).basicAdd(otherEnd, msgs);
            case STAMPPackage.UNSAFE_CONTROL_ACTION__OWNER:
                if (eInternalContainer() != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return basicSetOwner((STPAAnalysis)otherEnd, msgs);
        }
        return eDynamicInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPPackage.UNSAFE_CONTROL_ACTION__EANNOTATIONS:
                return ((InternalEList<?>)getEAnnotations()).basicRemove(otherEnd, msgs);
            case STAMPPackage.UNSAFE_CONTROL_ACTION__OWNED_NOTE:
                return ((InternalEList<?>)getOwnedNotes()).basicRemove(otherEnd, msgs);
            case STAMPPackage.UNSAFE_CONTROL_ACTION__OWNER:
                return basicSetOwner(null, msgs);
        }
        return eDynamicInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
        switch (eContainerFeatureID()) {
            case STAMPPackage.UNSAFE_CONTROL_ACTION__OWNER:
                return eInternalContainer().eInverseRemove(this, STAMPPackage.STPA_ANALYSIS__UNSAFE_CONTROL_ACTION, STPAAnalysis.class, msgs);
        }
        return eDynamicBasicRemoveFromContainer(msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case STAMPPackage.UNSAFE_CONTROL_ACTION__EANNOTATIONS:
                return getEAnnotations();
            case STAMPPackage.UNSAFE_CONTROL_ACTION__OWNED_NOTE:
                return getOwnedNotes();
            case STAMPPackage.UNSAFE_CONTROL_ACTION__ID:
                return getId();
            case STAMPPackage.UNSAFE_CONTROL_ACTION__DESCRIPTION:
                return getDescription();
            case STAMPPackage.UNSAFE_CONTROL_ACTION__CONTROL_ACTION:
                if (resolve) return getControlAction();
                return basicGetControlAction();
            case STAMPPackage.UNSAFE_CONTROL_ACTION__VIOLATING_SAFETY_CONSTRAINT:
                return getViolatingSafetyConstraints();
            case STAMPPackage.UNSAFE_CONTROL_ACTION__OWNER:
                if (resolve) return getOwner();
                return basicGetOwner();
        }
        return eDynamicGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case STAMPPackage.UNSAFE_CONTROL_ACTION__EANNOTATIONS:
                getEAnnotations().clear();
                getEAnnotations().addAll((Collection<? extends EAnnotation>)newValue);
                return;
            case STAMPPackage.UNSAFE_CONTROL_ACTION__OWNED_NOTE:
                getOwnedNotes().clear();
                getOwnedNotes().addAll((Collection<? extends Note>)newValue);
                return;
            case STAMPPackage.UNSAFE_CONTROL_ACTION__ID:
                setId((String)newValue);
                return;
            case STAMPPackage.UNSAFE_CONTROL_ACTION__DESCRIPTION:
                setDescription((String)newValue);
                return;
            case STAMPPackage.UNSAFE_CONTROL_ACTION__CONTROL_ACTION:
                setControlAction((ControlAction)newValue);
                return;
            case STAMPPackage.UNSAFE_CONTROL_ACTION__VIOLATING_SAFETY_CONSTRAINT:
                getViolatingSafetyConstraints().clear();
                getViolatingSafetyConstraints().addAll((Collection<? extends SafetyConstraint>)newValue);
                return;
            case STAMPPackage.UNSAFE_CONTROL_ACTION__OWNER:
                setOwner((STPAAnalysis)newValue);
                return;
        }
        eDynamicSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case STAMPPackage.UNSAFE_CONTROL_ACTION__EANNOTATIONS:
                getEAnnotations().clear();
                return;
            case STAMPPackage.UNSAFE_CONTROL_ACTION__OWNED_NOTE:
                getOwnedNotes().clear();
                return;
            case STAMPPackage.UNSAFE_CONTROL_ACTION__ID:
                setId(ID_EDEFAULT);
                return;
            case STAMPPackage.UNSAFE_CONTROL_ACTION__DESCRIPTION:
                setDescription(DESCRIPTION_EDEFAULT);
                return;
            case STAMPPackage.UNSAFE_CONTROL_ACTION__CONTROL_ACTION:
                setControlAction((ControlAction)null);
                return;
            case STAMPPackage.UNSAFE_CONTROL_ACTION__VIOLATING_SAFETY_CONSTRAINT:
                getViolatingSafetyConstraints().clear();
                return;
            case STAMPPackage.UNSAFE_CONTROL_ACTION__OWNER:
                setOwner((STPAAnalysis)null);
                return;
        }
        eDynamicUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case STAMPPackage.UNSAFE_CONTROL_ACTION__EANNOTATIONS:
                return eAnnotations != null && !eAnnotations.isEmpty();
            case STAMPPackage.UNSAFE_CONTROL_ACTION__OWNED_NOTE:
                return ownedNotes != null && !ownedNotes.isEmpty();
            case STAMPPackage.UNSAFE_CONTROL_ACTION__ID:
                return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
            case STAMPPackage.UNSAFE_CONTROL_ACTION__DESCRIPTION:
                return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
            case STAMPPackage.UNSAFE_CONTROL_ACTION__CONTROL_ACTION:
                return controlAction != null;
            case STAMPPackage.UNSAFE_CONTROL_ACTION__VIOLATING_SAFETY_CONSTRAINT:
                return violatingSafetyConstraints != null && !violatingSafetyConstraints.isEmpty();
            case STAMPPackage.UNSAFE_CONTROL_ACTION__OWNER:
                return basicGetOwner() != null;
        }
        return eDynamicIsSet(featureID);
    }

} //UnsafeControlActionImpl
