package net.astah.stpa.stamp.resource;

import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.xmi.XMIResource;

import net.astah.stpa.stamp.util.STAMPResourceFactoryImpl;

/**
 * STAMP/STPA モデルを格納するリソースのインタフェースです。
 */
public interface STAMPResource extends XMIResource {

    /**
     * STAMP/STPA モデルを格納するリソースを構築するファクトリのインタフェースです。
     */
    public interface Factory extends Resource.Factory {

        /**
         * デフォルトのインスタンスです。
         */
        public static final Factory INSTANCE = new STAMPResourceFactoryImpl();
    }

    /**
     * STAMP/STPA モデル用のリソースのファイルの拡張子です。
     */
    String FILE_EXTENSION = "stamp"; //$NON-NLS-1$

    /**
     * STAMP/STPA 向けの共有ライブラリモデルの基準 URI です。
     */
    String LIBRARIES_PATHMAP = "pathmap://STAMP_LIBRARIES/"; //$NON-NLS-1$

    /**
     * システム定義の HCF ヒントワードセットの共有ライブラリの URI です。
     */
    String HCF_HINT_WORD_SETS_LIBRARY_URI = LIBRARIES_PATHMAP + "HCFHintWordSets." + FILE_EXTENSION; //$NON-NLS-1$

}
